<?php

	if (!defined("_ECRIRE_INC_VERSION")) return;

	include_spip('inc/presentation');

	function spipimmo_install($action)
	{
		//les variables globales
		global $globals_spipimmo;

		switch ($action)
		{

			//Test des tables pour voir si elles existent
			case 'test':
				include_spip('base/abstract_sql');
				$desc1 = spip_abstract_showtable("spip_annonces", '', true);
				$desc2 = spip_abstract_showtable("spip_documents_annonces", '', true);
				$desc3 = spip_abstract_showtable("spip_types_offres", '', true);
				return ((isset($desc1['field']['id_annonce'])) and (isset($desc2['field']['id_document'])) and (isset($desc3['field']['id_type_offre'])));
				break;

			//Installation des tables
			case 'install':
				include_spip('base/create');
				include_spip('base/spipimmo');
				creer_base();
				ecrire_meta('version_spipimmo', $globals_spipimmo["version"]);

				//On remplit la table `spip_types_offres` si ncessaire {possibilit de mettre le code ailleurs?}
				$test=spip_query('SELECT * FROM `spip_types_offres`');
				$nbRes=spip_num_rows($test);
				if($nbRes<=0)
				{
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Maison / Villa')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Appartement')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Terrain')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Commerce')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Boutique')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Bureau / Local commercial')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Bureaux')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Parking')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Local')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Immeuble')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Hangar')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('H&ocirc;tel particulier')");
					spip_query("INSERT INTO `spip_types_offres` (`libelle_offre`) VALUES ('Divers')");
				}

				//cration rpertoire vignette
				if(!file_exists(_DIR_IMG . '/cache100xXXX'))
				{
					mkdir(_DIR_IMG . '/cache100xXXX');
				}

				break;

			//Desctruction des tables
			case 'uninstall':
				include_spip('base/abstract_sql');
				spip_query("DROP TABLE `spip_annonces`");
				spip_query("DROP TABLE `spip_documents_annonces`");
				spip_query("DROP TABLE `spip_types_offres`");

				//Suprression des documents
				$handle=opendir(_DIR_IMG);
				while($fichier = readdir($handle))
				{
					if(ereg("^immo[0-9]*-" . "[0-9]*.[a-zA-Z]*$", $fichier))
					{
						unlink(_DIR_IMG . $fichier);
					}
				}
				closedir($handle);


				if(file_exists($globals_spipimmo["repertoire_vignette"]))
				{
					$handle=opendir($globals_spipimmo["repertoire_vignette"]);
					while($fichier = readdir($handle))
					{
						if(ereg("^immo[0-9]*-" . "[0-9]*.[a-zA-Z]*$", $fichier))
						{
							unlink($globals_spipimmo["repertoire_vignette"] . $fichier);
						}
					}
					closedir($handle);
				}

				//Suppression meta
				effacer_meta('version_spipimmo');

				break;

			//Test de mise  jour
			case 'test_upgrade':
				include_spip('base/abstract_sql');
				$desc1 = spip_abstract_showtable("spip_annonces", '', true);
				$resUpdate=spip_query("SELECT * FROM `spip_annonces` LIMIT 0,1");
				$nbChamps=mysql_num_fields($resUpdate);

				return((isset($desc1['field']['id_annonce'])) and ($nbChamps==64));
				break;

			//Mise  jour depuis les premires versions
			case 'upgrade':
				include_spip('base/create');
				include_spip('base/spipimmo');

				//on remplace les "oui" et "non" par " 0" et "1"
				$tabOuiNon[""]=0;
				$tabOuiNon["Non"]=0;
				$tabOuiNon["Oui"]=1;
				$resListeAnnonce=spip_query("SELECT `id_annonce`, `publier`, `ascenseur`, `prestige`, `acces_handi`, `piscine`, `date_offre`, `date_modification` FROM `spip_annonces`");
				$nbAnnonce=spip_num_rows($resListeAnnonce);
				for($i=0; $i<$nbAnnonce; $i++)
				{
					$enrAnnonce=spip_fetch_array($resListeAnnonce);

					//Remplacement du format des dates
					$tabDateOffre=split("/",$enrAnnonce["date_offre"]);
					$tabDateModif=split("/",$enrAnnonce["date_modification"]);

					spip_query("UPDATE `spip_annonces` SET
						`acces_handi`=" . $tabOuiNon[$enrAnnonce["acces_handi"]] . ",
						`prestige`=" . $tabOuiNon[$enrAnnonce["prestige"]] . ",
						`ascenseur`=" . $tabOuiNon[$enrAnnonce["ascenseur"]] . ",
						`piscine`=" . $tabOuiNon[$enrAnnonce["piscine"]] . ",
						`publier`=" . $tabOuiNon[$enrAnnonce["publier"]] . ",
						`date_modification`=" . $tabDateModif[2] . "-" . $tabDateModif[1] . "-" . $tabDateModif[0] . ",
						`date_offre`=" . $tabDateOffre[2] . "-" . $tabDateOffre[1] . "-" . $tabDateOffre[0] ."
						WHERE `id_annonce`=" . $enrAnnonce["id_annonce"]);
				}

				//Table `spip_annonces`
				spip_query("ALTER TABLE `spip_annonces` MODIFY `id_annonce` int(50) AUTO_INCREMENT");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `publier` tinyint(1)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `type_offre` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `vente_location` varchar(8)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `n_mandat` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `type_mandat` varchar(50)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `date_offre` date");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `date_modification` date");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `date_disponibilite` date");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `negociateur` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `prix_loyer` int(30)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `honoraires` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `travaux` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `charges` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `depot_garantie` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `taxe_habitation` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `taxe_fonciere` int(10)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `adr_bien_1` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `adr_bien_2` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `cp_bien` int(5)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `ville_bien` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `cp_internet` int(5)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `ville_internet` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `quartier` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `residence` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `transport` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `proximite` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `secteur` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `categorie` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_pieces` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_chambres` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `surf_habit` int(6)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `surf_carrez` int(6)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `surf_sejour` int(6)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `surf_terrain` int(6)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `etage` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `code_etage` int(6)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_etage` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `annee_cons` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `type_cuisine` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_wc` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_sdb` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_sde` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_park_int` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_park_ext` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_garages` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `type_soussol` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_caves` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `type_chauf` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nat_chauf` varchar(255)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `ascenseur` int(2)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `balcon` int(4)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `terrasse` int(5)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `piscine` bool");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `acces_handi` bool");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `nb_murs_mit` int(1)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `facade_terrain` int(3)");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_annonce_fr` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_annonce_uk` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_annonce_sp` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_annonce_de` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_annonce_it` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `texte_mailing` longtext");
				spip_query("ALTER TABLE `spip_annonces` MODIFY `prestige` bool");
				spip_query("ALTER TABLE `spip_annonces` DROP `id_date`");

				//Table `spip_documents_annonces`
				spip_query("ALTER TABLE `spip_documents_annonces` MODIFY `id_document` int(11) AUTO_INCREMENT");
				spip_query("ALTER TABLE `spip_documents_annonces` MODIFY `numero_dossier` int(10)");
				spip_query("ALTER TABLE `spip_documents_annonces` MODIFY `fichier` varchar(255)");
				spip_query("ALTER TABLE `spip_documents_annonces` MODIFY `taille` int(11)");
				spip_query("ALTER TABLE `spip_documents_annonces` ADD `type` bool");
				spip_query("UPDATE `spip_documents_annonces` SET `type`='1'");

				//Suppression de mauvais documents
				$handle=opendir(_DIR_IMG);
				while($fichier = readdir($handle))
				{
					if(ereg("^o[0-9]*-" . "[0-9]*.[a-zA-Z]*$", $fichier))
					{
						unlink(_DIR_IMG . $fichier);
					}
				}
				closedir($handle);

				if(file_exists($globals_spipimmo["repertoire_vignette"]))
				{
					$handle=opendir($globals_spipimmo["repertoire_vignette"]);
					while($fichier = readdir($handle))
					{
						if(ereg("^o[0-9]*-" . "[0-9]*.[a-zA-Z]*$", $fichier))
						{
							unlink($globals_spipimmo["repertoire_vignette"] . $fichier);
						}
					}
					closedir($handle);
				}

				ecrire_meta('version_spipimmo', $globals_spipimmo["version"]);
				break;
		}
	}
?>